//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// [TPT] - itsonlyme:clientDetails START

#pragma once
#include "ResizableLib/ResizablePage.h"
#include "Modeless.h"	// SLUGFILLER: modelessDialogs
#include "ReqFiles.h"
#include "SharedFilesPage.h"

class CUpDownClient;

//////////////////////////////////////////////////////////////////////////////
// CClientDetailPage dialog

class CClientDetailPage : public CResizablePage
{
	DECLARE_DYNAMIC(CClientDetailPage)

public:
	CClientDetailPage();   // standard constructor
	virtual ~CClientDetailPage ();

	void SetMyclient(const CUpDownClient* client)	{m_client = client;}

// Dialog Data
	enum { IDD = IDD_SOURCEDETAILWND };

protected:
	CString m_strCaption;
	const CUpDownClient* m_client;

	void Localize();
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedApply(); 
};


//////////////////////////////////////////////////////////////////////////////
// CClientDetailDialog

class CClientDetailDialog : public CModelessResizableSheet	// SLUGFILLER: modelessDialogs
{
	DECLARE_DYNAMIC(CClientDetailDialog)

public:
	CClientDetailDialog(CUpDownClient* client, const LPCTSTR showPage = NULL);   // standard constructor
	virtual ~CClientDetailDialog();

	void	UpdateTree(CString newDir)	{ m_wndSharedFiles.UpdateTree(newDir); }	// itsonlyme: viewSharedFiles

protected:
	CUpDownClient* m_client;
	CClientDetailPage m_wndClientDetail;
	CReqFilesPage m_wndReqFiles;
	CSharedFilesPage m_wndSharedFiles;
	LPCTSTR m_showPage;

	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
};

// [TPT] - itsonlyme:clientDetails END
