// Modeless.cpp : implementation file
//

#include "stdafx.h"
#include "Modeless.h"
#include "emule.h"
#include "emuleDlg.h"
#include "PreferencesDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// SLUGFILLER: modelessDialogs

// CModelessPropertySheet

IMPLEMENT_DYNAMIC(CModelessPropertySheet, CPropertySheet)

CModelessPropertySheet::CModelessPropertySheet(BOOL bDeleteOnClose)
{
	m_bDeleteOnClose = bDeleteOnClose;
	m_bActive = FALSE;
}

BEGIN_MESSAGE_MAP(CModelessPropertySheet, CPropertySheet)
	ON_COMMAND(IDOK, OnOK)
	ON_COMMAND(IDCANCEL, OnCancel)
END_MESSAGE_MAP()

void CModelessPropertySheet::OpenDialog()
{
	if (!m_bActive) {
		m_bActive = TRUE;
		Create(theApp.emuledlg);
	}
	ShowWindow(SW_SHOW);
	SetFocus();
}

void CModelessPropertySheet::CloseDialog()
{
	if (m_bActive)
		DestroyWindow();
}

void CModelessPropertySheet::OnOK()
{
	SendMessage(WM_COMMAND, ID_APPLY_NOW);
	UpdateData();
	DestroyWindow();
}

void CModelessPropertySheet::OnCancel()
{
	DestroyWindow();
}

BOOL CModelessPropertySheet::OnInitDialog()
{
	BOOL old_bModeless = m_bModeless;
	UINT old_nFlags = m_nFlags;
	m_bModeless = FALSE;
	m_nFlags |= WF_CONTINUEMODAL;
	BOOL bResult = CPropertySheet::OnInitDialog();
	m_bModeless = old_bModeless;
	m_nFlags = old_nFlags;
	return bResult;
}

void CModelessPropertySheet::PostNcDestroy()
{
	m_bActive = FALSE;
	if (m_bDeleteOnClose)
		delete this;
}


// CModelessResizableSheet

IMPLEMENT_DYNAMIC(CModelessResizableSheet, CResizableSheet)

CModelessResizableSheet::CModelessResizableSheet(BOOL bDeleteOnClose)
{
	m_bDeleteOnClose = bDeleteOnClose;
	m_bActive = FALSE;
}

BEGIN_MESSAGE_MAP(CModelessResizableSheet, CResizableSheet)
	ON_COMMAND(IDOK, OnOK)
	ON_COMMAND(IDCANCEL, OnCancel)
END_MESSAGE_MAP()

void CModelessResizableSheet::OpenDialog()
{
	if (!m_bActive) {
		m_bActive = TRUE;
		Create(theApp.emuledlg);
	}
	ShowWindow(SW_SHOW);
	SetFocus();
}

void CModelessResizableSheet::CloseDialog()
{
	if (m_bActive)
		DestroyWindow();
}

void CModelessResizableSheet::OnOK()
{
	SendMessage(WM_COMMAND, ID_APPLY_NOW);
	UpdateData();
	DestroyWindow();
}

void CModelessResizableSheet::OnCancel()
{
	DestroyWindow();
}

BOOL CModelessResizableSheet::OnInitDialog()
{
	BOOL old_bModeless = m_bModeless;
	UINT old_nFlags = m_nFlags;
	m_bModeless = FALSE;
	m_nFlags |= WF_CONTINUEMODAL;
	BOOL bResult = CResizableSheet::OnInitDialog();
	m_bModeless = old_bModeless;
	m_nFlags = old_nFlags;
	return bResult;
}

void CModelessResizableSheet::PostNcDestroy()
{
	m_bActive = FALSE;
	if (m_bDeleteOnClose)
		delete this;
}


// CPreferencesPage

IMPLEMENT_DYNAMIC(CPreferencesPage, CPropertyPage)

CPreferencesPage::CPreferencesPage(UINT nIDTemplate)
	: CPropertyPage(nIDTemplate)
{
}

BEGIN_MESSAGE_MAP(CPreferencesPage, CPropertyPage)
END_MESSAGE_MAP()

BOOL CPreferencesPage::OnSetActive()
{
	CPropertyPage::OnSetActive();
	if ((CPreferencesDlg *)this->GetParent()) 
		((CPreferencesDlg *)this->GetParent())->UpdateSelection(this);
	return true;
}
